#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1

extern int      ShowBars = 100000;

       int      StSlopeKPeriod = 5;
       int      StSlopeDPeriod = 3;
       int      StSlopeSlowing = 3;
       int      StSlopePriceField = 0;
       int      StSlopeMAMethod = MODE_SMA;

extern double   SlSteepA = 0.0;
extern double   SlSteepB = 0.01;
extern double   StochDifSeg = 1.0;
extern int      BzToPk = 0;
extern double   StochV = 50;
extern double   StochVMin = 0;

extern bool     UseStochBzConfirm = false;
extern int      StochBz = 4;

extern bool     UseStochBzMaxConfirm = false;
extern int      StochBzMax = 35;
extern double   StochDifBegin = 5;

extern bool     UseStochDifPkConfirm = false;
extern double   StochDifPk = 1;

extern int      BzLookBk = 18;
extern double   PipDif = -66;

extern bool     SwingBarIsSignalBar = false;
extern bool     SwingBarIsPriorToSignalBar = false;

extern bool     UseAutoTradeAnalysis = false;
extern double   SigRatio = 0.15;
extern int      BzLow = 5;
extern int      BzHigh = 25;

extern bool     UseMAProximity = false;
extern int      MAProximityPips = 25;
extern int      MAProxPeriod = 30;
extern int      MAProxMethod = MODE_LWMA;
extern int      MAProxPrice = PRICE_CLOSE;

extern bool     UseMASlope = false;
extern double   MASlopeTreshold = 1;
extern int      MASlopePeriod = 30;
extern int      MASlopeStartShift = 1;
extern int      MASlopeEndShift = 0;
extern int      MASlopeMethod = MODE_LWMA;
extern int      MASlopePrice = PRICE_TYPICAL;

extern bool     UsePatterns = false;
extern bool     UseBullPatternBullishHammer = true;
extern bool     UseBullPatternMorningStar = true;
extern bool     UseBullPatternMorningDojiStar = true;
extern bool     UseBullPatternPiercingLine = true;
extern bool     UseBullPatternBullishEngulfing = true;
extern bool     UseBearPatternShootingShootStar = true;
extern bool     UseBearPatternEveningStar = true;
extern bool     UseBearPatternEveningDojiStar = true;
extern bool     UseBearPatternDarkCloudCover = true;
extern bool     UseBearPatternBearishEngulfing = true;

extern double   WickBody_Percent = 1.0;
extern double   Candle_WickBody_Percent = 0;
extern int      CandleLength = 0; // pips
extern double   Star_Body_Length = 0.5; // 5 pips
                                      // should be in pips, but indy adjusts for 4/5 digits while PatternRecognition not
extern double   Doji_Star_Ratio = 0;
extern double   Star_MinLength = 0; // pips
extern double   Doji_MinLength = 0; // pips
extern double   Piercing_Line_Ratio = 0.1;
extern int      Piercing_Candle_Length = 1; // should be 10 pips
                                      // should be in pips, but indy adjusts for 4/5 digits while PatternRecognition not
extern int      Engulfing_Length = 1; // should be M1-M15:10; M30:15; H1:25; H4:20; D1:30; W1:40; MN1:50 pips
                                      // should be in pips, but indy adjusts for 4/5 digits while PatternRecognition not

extern bool     UseConsecutiveCloseBars=false;

extern bool     UseLevelProximity = false;
extern int      LevelPips = 50;
extern bool     UseManualLevelProximity = false;
extern string   ManualLevels = "1.1111;1.2222;1.3333"; // enter manual SR levels here, separated by ";"
extern int      LevelProximityFrom = -1;
extern int      LevelProximityTo = 40;

extern int      ArrowUpSymbol = 233;
extern int      ArrowDownSymbol = 234;
extern double   ArrowDistanceATRs = 0.2;

extern bool     MakeSoundAlerts = false;
extern string   SoundFileName = "alert.wav";
extern bool     MakeBoxAlerts = true;
extern bool     MakeMailAlerts = false;

double Pnt;
double up[],dn[];
datetime last;

int init()
{
    IndicatorDigits(Digits);

    SetIndexBuffer(0,up);
    SetIndexBuffer(1,dn);

    SetIndexLabel(0, "Up");
    SetIndexLabel(1, "Down");

    SetIndexStyle(0, DRAW_ARROW);
    SetIndexStyle(1, DRAW_ARROW);

    SetIndexArrow(0, ArrowUpSymbol);
    SetIndexArrow(1, ArrowDownSymbol);

    Pnt = Point;
    if ((Digits == 3) || (Digits == 5))
        Pnt = 10 * Point;

    last = 0;

    return (0);
}

int deinit()
{
    return (0);
}

int start()
{
    int start, i;
    bool l, s;

    if (last == 0) {
        start = Bars - 1;
        if (start > ShowBars)
            start = ShowBars;
    } else {
        if (Time[0] <= last)
            return(0);
        start = 1;
    }
    last = Time[0];

    for (i=start; i>0; i--) {
        GetSignal(i, l, s);
        if ( l ) {
            up[i] = Low[i] - ArrowDistanceATRs*iATR(NULL,0,14,i);
            if ((i == 1) && (Time[0] > last)) {
                MakeAlert(true);
                last = Time[0];
            }
        }
        if ( s ) {
            dn[i] = High[i] + ArrowDistanceATRs*iATR(NULL,0,14,i);
            if ((i == 1) && (Time[0] > last)) {
                MakeAlert(false);
                last = Time[0];
            }
        }
    }

    return (0);
}

void MakeAlert(bool is_long)
{
    string s;

    if ( is_long )
        s = "Long";
    else
        s = "Short";

    s = s + " alert for "+Symbol()+"/"+TimeFrame()+" at "+TimeToStr(Time[0]);

    if ( MakeSoundAlerts )
        PlaySound("alert.wav");
    if ( MakeBoxAlerts )
        Alert(s);
    if ( MakeMailAlerts )
        SendMail(s, s);
}

string TimeFrame()
{
    string period;

    switch ( Period() ) {
        case PERIOD_M1:
        case PERIOD_M5:
        case PERIOD_M15:
        case PERIOD_M30:
            period = "M"+Period();
            break;

        case PERIOD_H1:
            period = "H1";
            break;

        case PERIOD_H4:
            period = "H4";
            break;

        case PERIOD_D1:
            period = "D1";
            break;

        case PERIOD_W1:
            period = "W1";
            break;

        case PERIOD_MN1:
            period = "MN1";
            break;
    }

    return(period);
}

void GetSignal(int bar, bool& l, bool& s)
{
    int i, bz2pk, swing_low_bar, swing_high_bar, b, e, len;
    double  sta, stb, stc, st, st_lowest, st_highest, swing_low, swing_high, lowest_low,
            highest_high, ma_prox, ma_slope, levels[], bp, p;
    bool    l_steep, s_steep, 
            l_stoch_val, s_stoch_val,
            l_stoch_lowest, s_stoch_highest,
            l_stoch_begin, s_stoch_begin,
            l_stoch_diff, s_stoch_diff,
            l_price_inc, s_price_dec,
            l_is_sig, s_is_sig,
            l_is_prior, s_is_prior,
            l_auto, s_auto,
            l_maproxim, s_maproxim,
            l_slope, s_slope,
            l_patterns, s_patterns,
            l_lvlproxim, s_lvlproxim,
            l_conscl,s_conscl;
    int long_patterns, short_patterns;

    // --------------------------------------------------------------
    stc = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, bar);
    stb = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, bar+1);
    sta = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, bar+2);
    l_steep = (stc-stb >= SlSteepB) && (stb-sta <= SlSteepA) && (stc-2*stb+sta >= StochDifSeg);
    s_steep = (stc-stb <= -SlSteepB) && (stb-sta >= -SlSteepA) && (stc-2*stb+sta <= -StochDifSeg);

    // --------------------------------------------------------------
    if ( SwingBarIsSignalBar ) {
        l_is_sig = (Low[bar] < Low[bar+1]);
        s_is_sig = (High[bar] > High[bar+1]);
    } else {
        l_is_sig = true;
        s_is_sig = true;
    }
    if ( SwingBarIsPriorToSignalBar ) {
        l_is_prior = ((Low[bar+1] < Low[bar]) && (Low[bar+1] < Low[bar+2])) || (Low[bar] < Low[bar+1]);
        s_is_prior = ((High[bar+1] > High[bar]) && (High[bar+1] > High[bar+2])) || (High[bar] > High[bar+1]);
    } else {
        l_is_prior = true;
        s_is_prior = true;
    }

    if ( UseMAProximity ) {
        ma_prox = MathAbs(Close[bar]-iMA(NULL,0,MAProxPeriod,0,MAProxMethod,MAProxPrice,bar));
        l_maproxim = (ma_prox <= MAProximityPips*Pnt);
        s_maproxim = (ma_prox <= MAProximityPips*Pnt);
    } else {
        l_maproxim = true;
        s_maproxim = true;
    }

    if ( UseMASlope ) {
        ma_slope = (    iMA(NULL,0,MASlopePeriod,0,MASlopeMethod,MASlopePrice,bar+MASlopeEndShift) - 
                        iMA(NULL,0,MASlopePeriod,0,MASlopeMethod,MASlopePrice,bar+MASlopeStartShift)    ) / 
                   (    (MASlopeStartShift-MASlopeEndShift)*Pnt );
        l_slope = (ma_slope >= MASlopeTreshold);
        s_slope = (ma_slope <= -MASlopeTreshold);
    } else {
        l_slope = true;
        s_slope = true;
    }

    if ( UsePatterns ) {
        GetPatterns(bar, long_patterns, short_patterns);
        l_patterns = (long_patterns > 0);
        s_patterns = (short_patterns > 0);
    } else {
        l_patterns = true;
        s_patterns = true;
    }

    if (UseLevelProximity || UseManualLevelProximity) {
        ArrayResize(levels, 0);

        if ( UseLevelProximity ) {
            bp = MathFloor(Close[bar] / (LevelPips*Pnt)) * LevelPips*Pnt;

            for (i=-5; i<=5; i++) {
                ArrayResize(levels, ArraySize(levels)+1);
                levels[ArraySize(levels)-1] = bp + i*LevelPips*Pnt;
            }
        }

        if ( UseManualLevelProximity ) {
            len = StringLen(ManualLevels);
            if (len > 0) {
                for (b=0; b<len; b=e+1) {
                    e = StringFind(ManualLevels, ";", b);
                    if (e == -1)
                        e = len;

                    p = StrToDouble( StringSubstr(ManualLevels, b, e-b) );

                    if (p > 0) {
                        ArrayResize(levels, ArraySize(levels)+1);
                        levels[ArraySize(levels)-1] = p;
                    }
                }
            }
        }

        l_lvlproxim = false;
        s_lvlproxim = false;
        for (i=ArraySize(levels)-1; i>=0; i--) {
            if ((Close[bar] >= levels[i]+LevelProximityFrom*Pnt) && (Close[bar] <= levels[i]+LevelProximityTo*Pnt))
                l_lvlproxim = true;
            if ((Close[bar] <= levels[i]-LevelProximityFrom*Pnt) && (Close[bar] >= levels[i]-LevelProximityTo*Pnt))
                s_lvlproxim = true;
        }
    } else {
        l_lvlproxim = true;
        s_lvlproxim = true;
    }

   //
   //
   //
   //
   //
   
    if ( !UseAutoTradeAnalysis ) {
        // --------------------------------------------------------------
        st_lowest = 100;
        st_highest = 0;
        for (i=bar; i<=bar+BzToPk; i++) {
            st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
            if (st < st_lowest)
                st_lowest = st;
            if (st > st_highest)
                st_highest = st;
        }
        l_stoch_val = (st_lowest <= StochV)      && (st_lowest >= StochVMin);
        s_stoch_val = (st_highest >= 100-StochV) && (st_highest <= 100-StochVMin);

        // --------------------------------------------------------------
        l_stoch_lowest = true;
        s_stoch_highest = true;
        if ( UseStochBzConfirm ) {
            st_lowest = 100;
            st_highest = 0;
            for (i=bar; i<=bar+BzToPk; i++) {
                st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
                if (st < st_lowest)
                    st_lowest = st;
                if (st > st_highest)
                    st_highest = st;
            }
            for (i=bar+BzToPk+1; i<=bar+StochBz; i++) {
                st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
                if (st < st_lowest)
                    l_stoch_lowest = false;
                if (st > st_highest)
                    s_stoch_highest = false;
            }
        }

        // --------------------------------------------------------------
        if ( UseStochBzMaxConfirm ) {
            l_stoch_begin = false;
            s_stoch_begin = false;
            for (i=bar; i<=bar+StochBzMax; i++) {
                st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
                if (st <= StochDifBegin)
                    l_stoch_begin = true;
                if (st >= 100-StochDifBegin)
                    s_stoch_begin = true;
            }
        } else {
            l_stoch_begin = true;
            s_stoch_begin = true;
        }

        // --------------------------------------------------------------
        if ( UseStochDifPkConfirm ) {
            l_stoch_diff = false;
            s_stoch_diff = false;
            st_lowest = 100;
            st_highest = 0;
            for (i=bar; i<=bar+BzToPk; i++) {
                st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
                if (st < st_lowest)
                    st_lowest = st;
                if (st > st_highest)
                    st_highest = st;
            }
            for (i=bar+BzToPk+1; i<=bar+StochBz; i++) {
                st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
                if (st-st_lowest >= StochDifPk)
                    l_stoch_diff = true;
                if (st_highest-st >= StochDifPk)
                    s_stoch_diff = true;
            }
        } else {
            l_stoch_diff = true;
            s_stoch_diff = true;
        }

        // --------------------------------------------------------------
        if (Low[bar] < Low[bar+1]) {
            swing_low = Low[bar];
            swing_low_bar = bar;
        } else
            swing_low = -1;
        if (High[bar] > High[bar+1]) {
            swing_high = High[bar];
            swing_high_bar = bar;
        } else
            swing_high = -1;
        for (i=bar+1; i<=bar+BzToPk; i++) {
            if ((swing_low == -1) || (Low[i] < swing_low)) {
                if ((Low[i] < Low[i+1]) && (Low[i] < Low[i-1])) {
                    swing_low = Low[i];
                    swing_low_bar = i;
                }
            }
            if ((swing_high == -1) || (High[i] > swing_high)) {
                if ((High[i] > High[i+1]) && (High[i] > High[i-1])) {
                    swing_high = High[i];
                    swing_high_bar = i;
                }
            }
        }
        if (swing_low > 0) {
            lowest_low = Low[swing_low_bar+1];
            for (i=swing_low_bar+1; i<=swing_low_bar+BzLookBk; i++)
                if (Low[i] < lowest_low)
                    lowest_low = Low[i];
        }
        if (swing_high > 0) {
            highest_high = High[swing_high_bar+1];
            for (i=swing_high_bar+1; i<=swing_high_bar+BzLookBk; i++)
                if (High[i] > highest_high)
                    highest_high = High[i];
        }
        
        if (swing_low > 0)
            l_price_inc = swing_low-lowest_low >= PipDif*Pnt;
        else
            l_price_inc = true;
        if (swing_high > 0)
            s_price_dec = highest_high-swing_high >= PipDif*Pnt;
        else
            s_price_dec = true;

        l = l_steep && l_stoch_val && l_stoch_lowest && l_stoch_begin && l_stoch_diff && l_price_inc && l_is_sig && l_is_prior && l_maproxim && l_slope && l_patterns && l_lvlproxim;
        s = s_steep && s_stoch_val && s_stoch_highest && s_stoch_begin && s_stoch_diff && s_price_dec && s_is_sig && s_is_prior && s_maproxim && s_slope && s_patterns && s_lvlproxim;
    } else {
        l_auto = false;
        s_auto  = false;

        if (Low[bar] < Low[bar+1]) {
            swing_low = Low[bar];
            swing_low_bar = bar;
        } else
            swing_low = -1;
        if (High[bar] > High[bar+1]) {
            swing_high = High[bar];
            swing_high_bar = bar;
        } else
            swing_high = -1;
        for (i=bar+1; i<=bar+BzToPk; i++) {
            if ((swing_low == -1) || (Low[i] < swing_low)) {
                if ((Low[i] < Low[i+1]) && (Low[i] < Low[i-1])) {
                    swing_low = Low[i];
                    swing_low_bar = i;
                }
            }
            if ((swing_high == -1) || (High[i] > swing_high)) {
                if ((High[i] > High[i+1]) && (High[i] > High[i-1])) {
                    swing_high = High[i];
                    swing_high_bar = i;
                }
            }
        }

        if (swing_low > 0) {
            for (bz2pk=BzLow; (bz2pk<=BzHigh) && !l_auto; bz2pk++) {
                lowest_low = swing_low;
                st_lowest = 100;
                for (i=swing_low_bar+1; i<=swing_low_bar+bz2pk; i++) {
                    st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
                    if (st < st_lowest)
                        st_lowest = st;
                    if (Low[i] < lowest_low)
                        lowest_low = Low[i];
                }
                if ((lowest_low < swing_low) && (st_lowest > 0)) {
                    if ((swing_low-lowest_low)/(Pnt*st_lowest) >= SigRatio*i/BzLow)
                        l_auto = true;
                }
            }
        }
        if (swing_high > 0) {
            for (bz2pk=BzLow; (bz2pk<=BzHigh) && !s_auto; bz2pk++) {
                highest_high = swing_high;
                st_highest = 0;
                for (i=swing_high_bar+1; i<=swing_high_bar+bz2pk; i++) {
                    st = iStochastic(NULL, 0, StSlopeKPeriod, StSlopeDPeriod, StSlopeSlowing, StSlopeMAMethod, StSlopePriceField, MODE_MAIN, i);
                    if (st > st_highest)
                        st_highest = st;
                    if (High[i] > highest_high)
                        highest_high = High[i];
                }
                if ((highest_high > swing_high) && (st_highest < 100)) {
                    if ((highest_high-swing_high)/(Pnt*(100-st_highest)) >= SigRatio*i/BzLow)
                        s_auto = true;
                }
            }
        }

        l = l_steep && l_is_sig && l_is_prior && l_auto && l_maproxim && l_slope && l_patterns && l_lvlproxim;
        s = s_steep && s_is_sig && s_is_prior && s_auto && s_maproxim && s_slope && s_patterns && s_lvlproxim;
    }

    if (UseConsecutiveCloseBars) {
        l_conscl = ((Close[bar]>Open[bar]) && (Close[bar] > Close[bar+1])) && ((Close[bar+1]>Open[bar+1]) && (Close[bar+1]>Close[bar+2]));
        s_conscl = ((Close[bar]<Open[bar]) && (Close[bar] < Close[bar+1])) && ((Close[bar+1]<Open[bar+1]) && (Close[bar+1]<Close[bar+2]));
    } else {
        l_conscl = true;
        s_conscl = true;
    }
   l = l && l_conscl;
   s = s && s_conscl;
}

void GetPatterns(int bar, int& long_patterns, int& short_patterns)
{
    double Wick, Body, BodyHigh, BodyLow, LW, UW, BL, BLa, BL90, CL;
    double O, O1, O2, C, C1, C2, L, L1, L2, L3, H, H1, H2, H3;

    long_patterns = 0;
    short_patterns = 0;

    O  = Open[bar];
    O1 = Open[bar+1];
    O2 = Open[bar+2];
    C  = Close[bar];
    C1 = Close[bar+1];
    C2 = Close[bar+2];
    L  = Low[bar];
    L1 = Low[bar+1];
    L2 = Low[bar+2];
    L3 = Low[bar+3];
    H  = High[bar];
    H1 = High[bar+1];
    H2 = High[bar+2];
    H3 = High[bar+3];

    if (O > C) {
        BodyHigh = O;
        BodyLow = C;
    } else {
        BodyHigh = C;
        BodyLow = O; 
    }
    Body = BodyHigh-BodyLow;
    Wick = H-L;
    LW = BodyLow-L;
    UW = H-BodyHigh;
    BL = O-C;
    BLa = MathAbs(BL);
    BL90 = BLa*Candle_WickBody_Percent;
    CL = H-L;

    if ( UseBullPatternBullishHammer ) {
     // Check for Bullish Hammer   
        if (    (L<=L1) && (L<L2) && (L<L3) && (Wick>=(Body*WickBody_Percent)) && ((LW/2)>UW) && (LW>BL90) &&
                (CL>=(CandleLength*Pnt)) && (O!=C) && ((LW/3)<=UW) && ((LW/4)<=UW))
            long_patterns++;

      // Check for Bullish Hammer   
        if (    (L<=L1) && (L<L2) && (L<L3) && (Wick>=(Body*WickBody_Percent)) && ((LW/3)>UW) && (LW>BL90) &&
                (CL>=(CandleLength*Pnt)) && (O!=C) && ((LW/4)<=UW))
            long_patterns++;

      // Check for Bullish Hammer   
        if (    (L<=L1) && (L<L2) && (L<L3) && (Wick>=(Body*WickBody_Percent)) && ((LW/4)>UW) && (LW>BL90) &&
                (CL>=(CandleLength*Pnt)) && (O!=C))
            long_patterns++;
    }

    if ( UseBullPatternMorningStar ) {
     // Check for Morning Star
        if (    (L<=L1) && (L1<L2) && (L1<L3) && (BLa<(Star_Body_Length*Pnt)) && (O!=C) && (O2>C2) && 
                ((O2-C2)/(0.001+H2-L2)>Doji_Star_Ratio) && (O1>C1) && (C>O) && (CL>=(Star_MinLength*Pnt)))
            long_patterns++;
    }

    if ( UseBullPatternMorningDojiStar ) {
      // Check for Morning Doji Star
        if (    (L<=L1) && (L1<L2) && (L1<L3) && (O==C) && (O2>C2) && ((O2-C2)/(0.001+H2-L2)>Doji_Star_Ratio) &&
                (O1>C1) && (CL>=(Doji_MinLength*Pnt)))
            long_patterns++;
    }

    if ( UseBullPatternPiercingLine ) {
      // Check for Piercing Line pattern
        if (    (C1<O1) && (((O1+C1)/2)<C) && (O<C) && ((C-O)/(0.001+(H-L))>Piercing_Line_Ratio) &&
                (CL>=(Piercing_Candle_Length*Point)))
            long_patterns++;
    }

    if ( UseBullPatternBullishEngulfing ) {
      // Check for Bullish Engulfing pattern
        if ((O1>C1) && (C>O) && (C>=O1) && (C1>=O) && ((C-O)>(O1-C1)) && (CL>=(Engulfing_Length*Pnt)))
            long_patterns++;
    }

    if ( UseBearPatternShootingShootStar ) {
      // Check for Bearish Shooting ShootStar
        if (    (H>=H1) && (H>H2) && (H>H3) && (Wick>=(Body*WickBody_Percent)) && ((UW/2)>LW) && (UW>(2*BL90)) &&
                (CL>=(CandleLength*Pnt)) && (O!=C) && ((UW/3)<=LW) && ((UW/4)<=LW))
            short_patterns++;

      // Check for Bearish Shooting ShootStar
        if (    (H>=H1) && (H>H2) && (H>H3) && (Wick>=(Body*WickBody_Percent)) && ((UW/3)>LW) && (UW>(2*BL90)) &&
                (CL>=(CandleLength*Pnt)) && (O!=C) && ((UW/4)<=LW))
            short_patterns++;

      // Check for Bearish Shooting ShootStar
        if (    (H>=H1) && (H>H2) && (H>H3) && (Wick>=(Body*WickBody_Percent)) && ((UW/4)>LW) && (UW>(2*BL90)) &&
                (CL>=(CandleLength*Pnt)) && (O!=C))
            short_patterns++;
    }

    if ( UseBearPatternEveningStar ) {
      // Check for Evening Star pattern
        if (    (H>=H1) && (H1>H2) && (H1>H3) && (BLa<(Star_Body_Length*Pnt)) && (C2>O2) && (O!=C) &&
                ((C2-O2)/(0.001+H2-L2)>Doji_Star_Ratio) && (C1>O1) && (O>C) && (CL>=(Star_MinLength*Pnt)))
            short_patterns++;
    }

    if ( UseBearPatternEveningDojiStar ) {
      // Check for Evening Doji Star pattern
        if (    (H>=H1) && (H1>H2) && (H1>H3) && (O==C) && (C2>O2) && ((C2-O2)/(0.001+H2-L2)>Doji_Star_Ratio) &&
                (C1>O1) && (CL>=(Doji_MinLength*Pnt)))
            short_patterns++;
    }

    if ( UseBearPatternDarkCloudCover ) {
      // Check for a Dark Cloud Cover pattern
        if (    (C1>O1) && (((C1+O1)/2)>C) && (O>C) && (C>O1) && ((O-C)/(0.001+(H-L))>Piercing_Line_Ratio) &&
                (CL>=(Piercing_Candle_Length*Pnt)))
            short_patterns++;
    }

    if ( UseBearPatternBearishEngulfing ) {
      // Check for Bearish Engulfing pattern
        if ((C1>O1) && (O>C) && (O>=C1) && (O1>=C) && ((O-C)>(C1-O1)) && (CL>=(Engulfing_Length*Pnt)))
            short_patterns++;
    }
}

